Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 2364)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting implemented (SadiqHuq)
+! 
+! 2319 2017-07-20 17:33:17Z suehring
 ! Remove print statements
 ! 
@@ -250,5 +253,6 @@
                canyon_height, canyon_wall_left, canyon_wall_south,             &
                canyon_width_x, canyon_width_y, constant_flux_layer,            &
-               coupling_char, dp_level_ind_b, dz, dz_max, dz_stretch_factor,   &
+               coupling_char, coupling_mode,                                   &
+               dp_level_ind_b, dz, dz_max, dz_stretch_factor,                  &
                dz_stretch_level, dz_stretch_level_index, grid_level, ibc_uv_b, &
                io_blocks, io_group, inflow_l, inflow_n, inflow_r, inflow_s,    &
@@ -285,4 +289,7 @@
     USE surface_mod,                                                           &
         ONLY:  get_topography_top_index, init_bc
+
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnested, vnest_init_grid
 
     IMPLICIT NONE
@@ -2000,4 +2007,8 @@
     CALL exchange_horiz( l_wall, nbgp )     
 
+!
+!-- Vertical nesting: communicate vertical grid level arrays between fine and
+!-- coarse grid
+    IF ( vnested )  CALL vnest_init_grid
 
  END SUBROUTINE init_grid
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 2364)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting implemented (SadiqHuq)
+! 
+! 2300 2017-06-29 13:31:14Z raasch
 ! host-specific settings removed
 ! 
@@ -228,4 +231,7 @@
         ONLY:  nxl_y, nxl_yd, nxl_z, nxr_y, nxr_yd, nxr_z, nyn_x, nyn_z, nys_x,&
                nys_z, nzb_x, nzb_y, nzb_yd, nzt_x, nzt_yd, nzt_y
+
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnested, vnest_init_pegrid_domain, vnest_init_pegrid_rank
 
     IMPLICIT NONE
@@ -335,4 +341,9 @@
 
 !
+!-- Vertical nesting: store four lists that identify partner ranks to exchange 
+!-- data
+    IF ( vnested )  CALL vnest_init_pegrid_rank
+
+!
 !-- Determine sub-topologies for transpositions
 !-- Transposition from z to x:
@@ -642,5 +653,5 @@
     CALL MPI_TYPE_COMMIT( type_xy, ierr )
 
-    IF ( TRIM( coupling_mode ) /= 'uncoupled' )  THEN
+    IF ( TRIM( coupling_mode ) /= 'uncoupled' .AND. .NOT. vnested )  THEN
    
 !
@@ -743,4 +754,8 @@
     ENDIF
 
+!
+!-- Store partner grid point co-ordinates as lists.
+!-- Create custom MPI vector datatypes for contiguous data transfer
+    IF ( vnested )  CALL vnest_init_pegrid_domain
 
 #endif
Index: palm/trunk/SOURCE/local_stop.f90
===================================================================
--- palm/trunk/SOURCE/local_stop.f90	(revision 2364)
+++ palm/trunk/SOURCE/local_stop.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting implemented (SadiqHuq)
+! 
+! 2101 2017-01-05 16:42:31Z suehring
 !
 ! 2000 2016-08-20 18:09:15Z knoop
@@ -75,4 +78,7 @@
         ONLY:  nested_run
 
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnested
+
 #if defined( __parallel )
     IF ( coupling_mode == 'uncoupled' )  THEN
@@ -92,4 +98,11 @@
           ENDIF
        ENDIF
+    ELSEIF ( coupling_mode(1:8) == 'vnested_' )  THEN
+
+       PRINT*, '+++ local_stop:'
+       PRINT*, '     model "', TRIM( coupling_mode ), '" terminated'
+!
+!--    Abort both coarse and fine grid
+       CALL MPI_ABORT( MPI_COMM_WORLD, 9999, ierr )
     ELSE
 
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 2364)
+++ palm/trunk/SOURCE/parin.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical grid nesting: add vnest_start_time to d3par (SadiqHuq)
+! 
+! 2339 2017-08-07 13:55:26Z gronemeier
 ! corrected timestamp in header
 ! 
@@ -354,4 +357,6 @@
         ONLY:  wtm_parin
 
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnest_start_time
 
     IMPLICIT NONE
@@ -445,5 +450,5 @@
              skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,          &
              skip_time_do3d, skip_time_domask, synchronous_exchange,           &
-             termination_time_needed, z_max_do2d
+             termination_time_needed, vnest_start_time, z_max_do2d
 
 
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 2364)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical grid nesting implemented (SadiqHuq)
+! 
+! 2339 2017-08-07 13:55:26Z gronemeier
 ! corrected timestamp in header
 ! 
@@ -251,4 +254,7 @@
     USE synthetic_turbulence_generator_mod,                                    &
         ONLY:  stg_read_restart_data
+
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnest_init
 
     IMPLICIT NONE
@@ -785,5 +791,7 @@
              READ ( 13 )  vg_vertical_gradient_level_ind
           CASE ( 'virtual_flight' )
-             READ ( 13 ) virtual_flight
+             READ ( 13 )  virtual_flight
+          CASE ( 'vnest_init' )
+             READ ( 13 )  vnest_init
           CASE ( 'volume_flow_area' )
              READ ( 13 )  volume_flow_area
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 2364)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical grid nesting implemented (SadiqHuq)
+! 
+! 2320 2017-07-21 12:47:43Z suehring
 ! Set bottom boundary conditions after nesting interpolation and anterpolation
 ! 
@@ -399,4 +402,10 @@
         ONLY:  wind_turbine, wtm_forces
 
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnested, vnest_anterpolate, vnest_anterpolate_e,                &
+               vnest_boundary_conds, vnest_boundary_conds_khkm,                & 
+               vnest_deallocate, vnest_init, vnest_init_fine,                  &
+               vnest_start_time
+
     IMPLICIT NONE
 
@@ -429,5 +438,5 @@
 !-- Data exchange between coupled models in case that a call has been omitted 
 !-- at the end of the previous run of a job chain.
-    IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled )  THEN
+    IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled .AND. .NOT. vnested)  THEN
 !
 !--    In case of model termination initiated by the local model the coupler 
@@ -458,4 +467,14 @@
        CALL cpu_log( log_point_s(10), 'timesteps', 'start' )
 !
+!--    Vertical nesting: initialize fine grid
+       IF ( vnested ) THEN
+          IF ( .NOT. vnest_init  .AND.  simulated_time >= vnest_start_time )  THEN
+             CALL cpu_log( log_point(80), 'vnest_init', 'start' )
+             CALL vnest_init_fine
+             vnest_init = .TRUE.
+             CALL cpu_log( log_point(80), 'vnest_init', 'stop' )
+          ENDIF
+       ENDIF
+!
 !--    Determine ug, vg and w_subs in dependence on data from external file 
 !--    LSF_DATA
@@ -624,4 +643,12 @@
 !--       Swap the time levels in preparation for the next time step.
           CALL swap_timelevel
+
+!
+!--       Vertical nesting: Interpolate fine grid data to the coarse grid
+          IF ( vnest_init ) THEN
+             CALL cpu_log( log_point(81), 'vnest_anterpolate', 'start' )
+             CALL vnest_anterpolate
+             CALL cpu_log( log_point(81), 'vnest_anterpolate', 'stop' )
+          ENDIF
 
           IF ( nested_run )  THEN
@@ -736,5 +763,28 @@
           IF ( intermediate_timestep_count == 1  .OR. &
                 call_psolver_at_all_substeps )  THEN
-             CALL pres
+
+             IF (  vnest_init ) THEN
+!
+!--             Compute pressure in the CG, interpolate top boundary conditions
+!--             to the FG and then compute pressure in the FG
+                IF ( coupling_mode == 'vnested_crse' )  CALL pres
+
+                CALL cpu_log( log_point(82), 'vnest_bc', 'start' )
+                CALL vnest_boundary_conds
+                CALL cpu_log( log_point(82), 'vnest_bc', 'stop' )
+ 
+                IF ( coupling_mode == 'vnested_fine' )  CALL pres
+
+!--             Anterpolate TKE, satisfy Germano Identity
+                CALL cpu_log( log_point(83), 'vnest_anter_e', 'start' )
+                CALL vnest_anterpolate_e
+                CALL cpu_log( log_point(83), 'vnest_anter_e', 'stop' )
+
+             ELSE
+
+                CALL pres
+
+             ENDIF
+
           ENDIF
 
@@ -910,5 +960,6 @@
 !
 !--    Data exchange between coupled models
-       IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled )  THEN
+       IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled                   &
+                                          .AND. .NOT. vnested )  THEN
           time_coupling = time_coupling + dt_3d
 
@@ -1154,4 +1205,7 @@
     ENDDO   ! time loop
 
+!-- Vertical nesting: Deallocate variables initialized for vertical nesting    
+    IF ( vnest_init )  CALL vnest_deallocate
+
     IF ( myid == 0 )  CALL finish_progress_bar
 
Index: palm/trunk/SOURCE/timestep.f90
===================================================================
--- palm/trunk/SOURCE/timestep.f90	(revision 2364)
+++ palm/trunk/SOURCE/timestep.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical grid nesting: Sync fine and coarse grid timestep (SadiqHuq)
+! 
+! 2258 2017-06-08 07:55:13Z suehring
 ! Bugfix, add pre-preprocessor directives to enable non-parrallel mode
 !
@@ -137,4 +140,7 @@
         ONLY:  flow_statistics_called, hom, u_max, u_max_ijk, v_max, v_max_ijk,&
                w_max, w_max_ijk
+
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnested, vnest_timestep_sync
 
     IMPLICIT NONE
@@ -376,4 +382,8 @@
     ENDIF
 
+!
+!-- Vertical nesting: coarse and fine grid timestep has to be identical    
+    IF ( vnested )  CALL vnest_timestep_sync
+
     CALL cpu_log( log_point(12), 'calculate_timestep', 'stop' )
 
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 2364)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 2365)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vertical nesting implemented (SadiqHuq)
+! 
+! 2339 2017-08-07 13:55:26Z gronemeier
 ! corrected timestamp in header
 ! 
@@ -224,4 +227,6 @@
                v_max_ijk, w_max, w_max_ijk
 
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnest_init
 
     IMPLICIT NONE
@@ -695,4 +700,6 @@
     WRITE ( 14 )  'virtual_flight                '
     WRITE ( 14 )  virtual_flight
+    WRITE ( 14 )  'vnest_init                    '
+    WRITE ( 14 )  vnest_init
     WRITE ( 14 )  'volume_flow_area              '
     WRITE ( 14 )  volume_flow_area
Index: palm/trunk/UTIL/combine_plot_fields.f90
===================================================================
--- palm/trunk/UTIL/combine_plot_fields.f90	(revision 2364)
+++ palm/trunk/UTIL/combine_plot_fields.f90	(revision 2365)
@@ -21,8 +21,11 @@
 ! -----------------
 ! 
-!
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Vertical grid nesting implemented (SadiqHuq)
+!
+! 1809 2016-04-05 20:13:28Z raasch
 !
 ! 1808 2016-04-05 19:44:00Z raasch
@@ -120,4 +123,5 @@
     LOGICAL  ::  avs_output, compressed, found, iso2d_output, netcdf_output,   &
                  netcdf_parallel, netcdf_0, netcdf_1
+    LOGICAL  ::  vnest
 
     REAL(wp) ::  cpu_start_time, cpu_end_time, dx, simulated_time
@@ -126,4 +130,6 @@
     REAL(spk), DIMENSION(:,:,:), ALLOCATABLE ::  pf3d, pf3d_tmp
 
+
+
     PRINT*, ''
     PRINT*, ''
@@ -133,7 +139,11 @@
 !-- Find out if a coupled run has been carried out
     INQUIRE( FILE='COUPLING_PORT_OPENED', EXIST=found )
+    INQUIRE( FILE='VNESTING_PORT_OPENED', EXIST=vnest )
     IF ( found )  THEN
        models = 2
        PRINT*, '    coupled run'
+    ELSEIF ( vnest )  THEN
+       models = 2
+       PRINT*, '    Vertically nested grid coupling'
     ELSE
        models = 1
@@ -160,10 +170,21 @@
           PRINT*, '*** combine_plot_fields ***'
           IF ( model == 2 )  THEN
-             model_string = '_O'
-             PRINT*, '    now combining ocean data'
-             PRINT*, '    ========================'
+             IF ( vnest )  THEN
+                model_string = '_N'
+                PRINT*, '    now combining FINE data'
+                PRINT*, '    ========================'
+             ELSE
+                model_string = '_O'
+                PRINT*, '    now combining ocean data'
+                PRINT*, '    ========================'
+             ENDIF
           ELSE
-             PRINT*, '    now combining atmosphere data'
-             PRINT*, '    ============================='
+             IF ( vnest )  THEN
+                PRINT*, '    now combining COARSE data'
+                PRINT*, '    ============================='
+             ELSE
+                PRINT*, '    now combining atmosphere data'
+                PRINT*, '    ============================='
+             ENDIF
           ENDIF
        ENDIF
